/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.testframework;

import java.io.File;


/**
 * This is an abstract test class that contains the test cases for the functionality declare din {@link
 * ApplicationServer}.
 *
 * @author TCSDEVELOPER
 * @version 1.0
 */
public abstract class AbstractApplicationServerTest extends AbstractServerTest {
    /**
     * This is the instance to be tested, created in {@link #setUp()}.
     */
    private ApplicationServer applicationServer;

    /**
     * This method tests {@link ApplicationServer#setWarFile(java.io.File)}  and {@link
     * com.topcoder.testframework.ApplicationServer#getWarFile()}for correctness.
     */
    public void testGetSetWarFile() {
        assertEquals("unexpected initial value", null, applicationServer.getWarFile());
        final File file = new File(".");
        applicationServer.setWarFile(file);
        assertEquals("setter does not work", file, applicationServer.getWarFile());
    }

    /**
     * This method tests {@link ApplicationServer#setEarFile(java.io.File)}  and {@link
     * com.topcoder.testframework.ApplicationServer#getEarFile()}for correctness.
     */
    public void testGetSetEarFile() {
        assertEquals("unexpected initial value", null, applicationServer.getEarFile());
        final File file = new File(".");
        applicationServer.setEarFile(file);
        assertEquals("setter does not work", file, applicationServer.getEarFile());
    }

    /**
     * This method creates the instance to be tested by calling the constructor using the given type value as argument.
     *
     * @param type the type value to be used as constructor argument
     *
     * @return the instance created
     */
    protected Server createInstance(final String type) {
        return createApplicationServer(type);
    }

    /**
     * This method creates the {@link ApplicationServer} instance to be tested by calling the constructor using the
     * given type value as argument.
     *
     * @param type the type value to be used as constructor argument
     *
     * @return the instance created
     */
    protected abstract ApplicationServer createApplicationServer(String type);

    /**
     * This method does the test setup needed.
     *
     * @throws Exception in case some unexpected Exception occurs
     */
    protected void setUp() throws Exception {
        super.setUp();
        applicationServer = createApplicationServer(TYPE);
    }
}
