/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.testframework.web;

import junit.framework.TestCase;
import org.apache.cactus.server.HttpServletRequestWrapper;
import org.apache.cactus.server.ServletConfigWrapper;

import javax.servlet.http.HttpServletResponse;


/**
 * This class contains the unit tests for {@link TCServletTestCase}.
 *
 * @author TCSDEVELOPER
 * @version 1.0
 */
public class TCServletTestCaseTest extends TestCase {
    /**
     * This is a name used in test cases.
     */
    private static final String NAME = "testxxNamexx";
    /**
     * This is the instance to be tested. It is created in {@link #setUp()}.
     */
    private TCServletTestCase testCase;

    /**
     * This method tests {@link TCServletTestCase#TCServletTestCase()} for correctness.
     */
    public void testNoArgCtor() {
        final TCServletTestCase instance = new TCServletTestCase();
        assertNull("constructor does not assign all fields", instance.getConfig());
        assertNull("constructor does not assign all fields", instance.getSession());
        assertNull("constructor does not assign all fields", instance.getRequest());
        assertNull("constructor does not assign all fields", instance.getResponse());
        assertNull("constructor does not assign all fields", instance.getName());
    }

    /**
     * This method tests {@link TCServletTestCase#TCServletTestCase(String)} for correctness.
     */
    public void testOneArgCtor() {
        final TCServletTestCase instance = new TCServletTestCase(TCServletTestCaseTest.NAME);
        assertNull("constructor does not assign all fields", instance.getConfig());
        assertNull("constructor does not assign all fields", instance.getSession());
        assertNull("constructor does not assign all fields", instance.getRequest());
        assertNull("constructor does not assign all fields", instance.getResponse());
        assertEquals("constructor does not assign all fields", TCServletTestCaseTest.NAME, instance.getName());
    }

    /**
     * This method tests {@link TCServletTestCase#getConfig()} for correctness.
     */
    public void testGetConfig() {
        assertNull(testCase.getConfig());
        final ServletConfigWrapper configWrapper = new ServletConfigWrapper(null);
        testCase.config = configWrapper;
        assertEquals(configWrapper, testCase.getConfig());
    }

    /**
     * This method tests {@link TCServletTestCase#getSession()} for correctness.
     */
    public void testGetServletChain() {
        assertNull(testCase.getSession());
        final DummySession session = new DummySession();
        testCase.session = session;
        assertEquals(session, testCase.getSession());
    }

    /**
     * This method tests {@link TCServletTestCase#getRequest()} for correctness.
     */
    public void testGetRequest() {
        assertNull(testCase.getRequest());
        final HttpServletRequestWrapper requestWrapper = new HttpServletRequestWrapper(null, null);
        testCase.request = requestWrapper;
        assertEquals(requestWrapper, testCase.getRequest());
    }

    /**
     * This method tests {@link TCServletTestCase#getResponse()} for correctness.
     */
    public void testGetResponse() {
        assertNull(testCase.getResponse());

        final HttpServletResponse response = new DummyHttpServletResponse();
        testCase.response = response;
        assertEquals(response, testCase.getResponse());
    }

    /**
     * This method does the test setup needed.
     *
     * @throws Exception in case some unexpected Exception occurs
     */
    protected void setUp() throws Exception {
        super.setUp();
        testCase = new TCServletTestCase();
    }

}
